SystemOrganization addCategory: #'Xenon-Tests'!

TestCase subclass: #XeTranslateFunctionTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'convenience' stamp: 'BernardoContreras 4/7/2012 03:38'!
assert: expected equalsTranslationOf: aClass
	" assert expected equals the the translation of aClass"

	| actual |
	cg addClass: aClass.
	actual := cg codeString.
	self assert: expected contents equals: actual! !

!XeTranslateFunctionTest methodsFor: 'convenience' stamp: 'BernardoContreras 4/7/2012 03:58'!
expectWith
	^ XeExpected new! !

!XeTranslateFunctionTest methodsFor: 'running' stamp: 'BernardoContreras 4/3/2012 21:05'!
setUp
	cg := XeCodeGenerator new! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 18:50'!
testTranslateFunctionReturnZero
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected tab.
	expected << 'return 0;'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWhenReturnZeroScenario! !

!XeTranslateFunctionTest methodsFor: 'tests errors' stamp: 'BernardoContreras 4/5/2012 15:22'!
testTranslateFunctionWhenItHasManyReturnTypes
	cg addClass: XeFunctionThatHasManyReturnTypeScenario.
	self should: [cg codeString] raise: XeTooManyReturnTypesError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 19:14'!
testTranslateFunctionWhenReturnTypeIsDefault
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'sqInt foo(void);'.
	expected << 'sqInt foo(void){'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWithDefaultReturnTypeScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 19:15'!
testTranslateFunctionWhenReturnTypeIsInteger
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWhenReturnTypeIsIntegerScenario! !

!XeTranslateFunctionTest methodsFor: 'tests errors' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsUnknown
	cg addClass: XeFunctionWhenReturnTypeIsUnknownScenario.
	self should: [ cg codeString ] raise: XeTypeNotFoundError! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 05:07'!
testTranslateFunctionWithOneArgument
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'int foo(sqInt x);'.
	expected << 'int foo(sqInt x){'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWithOneArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 05:07'!
testTranslateFunctionWithOneIntegerArgument
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'int foo(int x);'.
	expected << 'int foo(int x){'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWithOneIntegerArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/7/2012 05:07'!
testTranslateFunctionWithTwoArguments
	| expected |
	expected := self expectWith functionPrototypesComment.
	expected << 'int fooand(sqInt x, sqInt y);'.
	expected << 'int fooand(sqInt x, sqInt y){'.
	expected << '}'.
	self assert: expected equalsTranslationOf: XeFunctionWithTwoArgumentsScenario! !

Object subclass: #XeExpected
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 05:05'!
<< aCollection
	stream
		nextPutAll: aCollection;
		cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 03:05'!
contents
	^ stream contents! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 05:08'!
functionPrototypesComment
	self << '/*** Function Prototypes ***/'! !

!XeExpected methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/7/2012 03:02'!
initialize
	stream := WriteStream on: (String new: 1000)! !

!XeExpected methodsFor: 'printing' stamp: 'BernardoContreras 4/7/2012 04:00'!
printOn: aStream
	aStream nextPutAll: 'expects '.
	aStream
		nextPut: $[;
		cr.
	aStream nextPutAll: stream contents.
	aStream nextPut: $]! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 03:03'!
tab
	stream tab! !

Object subclass: #XeFunctionThatHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionThatHasManyReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:20' prior: 0!
A function that has many return types


!

!XeFunctionThatHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

Object subclass: #XeFunctionWhenReturnZeroScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnZeroScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 18:49'!
foo
	<returnType: #int>
	^ 0
		
! !

Object subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithOneArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 15:24' prior: 0!
A function with one argument.
!

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithOneIntegerArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithOneIntegerArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 17:06' prior: 0!
A function with one integer argument.
!

!XeFunctionWithOneIntegerArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 16:05'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithTwoArgumentsScenario commentStamp: 'BernardoContreras 4/5/2012 15:25' prior: 0!
A function with two arguments.


!

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/3/2012 23:36'!
foo: x and: y
	<returnType: #int>
! !
